<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <meta http-equiv="CONTENT-TYPE" content="text/html; charset=UTF-8">
  <title>glideinWMS - Factory</title>
  <meta name="CREATED" content="0;0">
  <meta name="CHANGED" content="20100521;20081031;14115200">    
  <link rel="stylesheet" type="text/css" href="../common/glideinWMS.css" media="screen, projection" />
</head>

<body lang="en-US" dir="ltr">
    <h1>
        <a href="index.html">GlideinWMS</a>
	<span>The Glidein-based Workflow Management System</span>
    </h1>
    <ul class="breadcrumbs">
	    <li> <a href="../index.html">Home</a></li>
	    <li> <a href="./index.html">WMS Factory</a></li>
        <li>Overview</li>
    </ul>
    <div class="clear" />
    <div class="leftmenu">
        <ul class="components">
	        <li> <a href="../index.html">Home</a></li>
	        <li> <a href="../download.html">Download</a></li>
	        <li> <a href="../frontend/index.html">Glidein Frontend</a></li>
            <li> <a href="../corral.html">Corral Frontend</a></li>
	        <li> <a href="../factory/index.html">WMS Factory</a></li>
	        <li> <a href="../components/index.html" >Components</a></li>
	        <li> <a href="../components/faq.html" class="last">FAQ</a></li>
        </ul>
        <div class="search">
            <div id="cse-search-form" style="width: 100%;">Loading</div>
            <script src="http://www.google.com/jsapi" type="text/javascript"></script>
            <script src="../common/glidein.js" type="text/javascript"></script>
            <script type="text/javascript">
            google.load('search', '1', {language : 'en', style : google.loader.themes.MINIMALIST});
            google.setOnLoadCallback(onLoad);
            </script>
        </div>
    </div>
    <div id="searchcontent"><h2>Search Results</h2><div id="cse"></div> </div>
<div class="content">
    <div class="heading">
    <img align="right" width="280px" border="0px"
        src="../images/simple_diagram.png" usemap="#rightimage">
    <map name="rightimage">
        <area shape="rect" coords="90,3,177,60" href="../frontend/index.html" />
        <area shape="rect" coords="5,88,118,146" href="../components/collector_install.html" />
        <area shape="rect" coords="134,88,275,146" href="../factory/index.html" />
        <area shape="rect" coords="189,3,274,60" target="_blank" href="../corral.html" />
    </map>

    <h2>WMS Factory</h2>
	<ul class="subcomponents">
	     <li>Overview</li>
         <li> <a href="./install.html">Install</a></li>
	     <li> <a href="./configuration.html">Configuration</a></li>
	     <li> <a href="./design.html">Design</a></li>
	     <li> <a href="./monitoring.html">Monitoring</a></li>
	     <li class="last"> <a href="./troubleshooting.html">Troubleshooting</a></li>
	</ul>
        <h3>Overview</h3>
	</div>
<div class="jump">
<u>Jump to:</u>
<ol>
    <LI><A HREF="#overview">Overview</A> 
    <LI><A HREF="#philosophy">Factory Philosophy</A> 
    <li><a href="#management">Factory Management</a> 
    </li>
</ol>
</div>
<div class="related">
Related Links: <br/>
<ul>
    <li><a href="install.html">Factory Install</a></li>
    <li><a href="install.html">Configuration Variable Reference</a></li>
</ul>
</div>
<div class="section">

<H2><A NAME="overview"></A>Overview</H2>
<P><A NAME="glidein_entry_point"></A>The main task of the Glidein
Factory is to advertise itself, listen for requests from <A HREF="../frontend/index.html">frontend
clients</A> and submit <A HREF="../index.html#glideins">glideins</A>.
Look at the picture below for a schematic view.
</p>
<p>
<IMG SRC="../images/factory_overview.png" NAME="graphics1" ALIGN=BOTTOM WIDTH=80% BORDER=0></p><p>

A single glidein factory can handle multiple kinds of glideins, also
called <B>glidein entry points</B> (as they usually point to
different Grid resources). For each entry point, it will advertise a
different class-ad. <BR>Similarly, each request from a frontend
client will affect a single entry point; a frontend will need to
advertise several requests in order to have glideins submitted to all
the desirable resources.</P>

</div>



<div class="section">
<H2><A NAME="philosophy"></A>The Glidein Factory philosophy</H2>
<P>The main idea behind a Glidein Factory is to make the life of a VO
frontend as easy as possible. And to do that, the factory needs to
abstract as much as possible. </p>
<p>
    For starters, the factory itself is the one that knows the details 
of various Grid sites and properly configures the glidein entry points, 
so they will run without any additional knowledge. A frontend only needs 
to know that an entry point exists, and the parameters it takes.
</p>
<p>
    Additionally, the factory also does the submissions themselves. 
The frontend just publishes that it needs some glideins and the factory 
will start submitting them. The only handle the frontend may want to use 
is the ability to regulate the rate of glideins that are sent to the
Grid site. In the current implementation, this can be achieved by
setting the desired number of 
<A HREF="http://www.cs.wisc.edu/condor/manual/v7.0/2_6Managing_Job.html#SECTION00361000000000000000">idle glideins</A> 

to be kept in the Grid queue.
</p>
<p>
    The <A HREF="../images/factory_overview.png" TARGET="_blank">typical scenario</A> 
features a frontend with several (hundreds or even
thousands of) user jobs in the queue that is looking for resources to
run them. It will fetch the factory classads, select the ones that
satisfy its needs, and advertise class-ads with requests for those
glideins. If the frontend ever runs out of user jobs, it will
advertise the fact that it does not need those glideins anymore. In
practical terms, this means asking the factory to keep exactly 0 idle
glideins in the queue.</P>
</div>


<div class="section">
<H2><A NAME="management"></A>Factory Management At a Glance</H2>
<p>
    Here are some common tasks you may need to do as a factory admin 
    (with links to more information):
</p>
<ul>
    <li><a href="install.html#factory_manual">
        Creating a new configuration directory</a>:
        <tt>glideinWMS/creation/create_glidein</tt></li>
    <li><a href="install.html#starting">
        Starting and Stopping the Factory</a>:
        <tt>&lt;glidein directory&gt;/factory_startup
        start|stop|restart|status</tt></li>
    <li><a href="configuration.html">Configuration</a> can be found in either
        <tt>factory.xml</tt> or <tt>glideinWMS.xml</tt> in your factory's
        instance directory (depending on your installation method).</li>
    <li>After modifying the xml, be sure to 
        <a href="install.html#factory_update">reconfig</a> your factory:
        <tt>&lt;glidein directory&gt;/factory_startup
        reconfig <i>config_copy_fname</i></tt></li>
    <li><a href="install.html#downtimes">Add a downtime</a>
        with: <tt>&lt;glidein directory&gt;/factory_startup
        up|down -entry 'factory'|&lt;entry name&gt; [-delay &lt;delay&gt;]
        </tt></li>
    <li><a href="monitoring.html">Monitoring the factory</a></li>
</ul>
</div>

<div class="footer">
Banner image by
<a href="http://www.flickr.com/people/leafwarbler/">Madhusudan Katti</a>
used under Creative Commons license.<br/>
Original Home URL: <a href="http://www.uscms.org/SoftwareComputing/Grid/WMS/glid
einWMS">http://www.uscms.org/SoftwareComputing/Grid/WMS/glideinWMS</a>.
glideinWMS email support: glideinwms-support at fnal.gov
</div>



</div>


</div>
</body>
</html>
